# Bu dosya ana pencere için kodlama içeriğini oluşturur.
# ana pencere için  görsel  düzenlemeri "main_form_ui_edit" dosyasında yapılmalıdır. 
# main_form.ui* dosyası QtDesigner ile oluşturulmuştur.
# main_form_ui_to_py.py** dosyası ui uzantılı QtDesigner dosyasını main_form_ui.py dosyasına dönüştürür.
# main_form_ui.py*** dosyası uic kütüphanesi ile python kodlarına dönüştürülmiş QtDesigner tasarımını içerir
# *,**,*** Bu üç dosyaya müdahele edilmemelidir. 

import sys                  # sys modulunu içe aktarıyoruz. Bu dosyada sadece test için gereklidir.
import main_form_ui_edit    # QtDesigner tarafından oluşturulan tasarım kodlarını barındıran dosyayı dahil ediyoruz.
import search_ui_code       # Karakter kodlaması arama yardımcı penceresi kodlarını dahil ediyoruz. 
import unicodedata

# main_form_ui.py dosyasındaki kodlar sadece tasarım içindir. Bu dosyada bir 
# pencere ve uygulama oluşturulacağı için aşağıdaki modulleri de koda dahil ediyoruz.
from PyQt5.QtWidgets import QWidget,QApplication, QMessageBox,QMainWindow,QStatusBar,QFrame,QLabel,QPushButton,QProgressBar
from PyQt5.Qt import Qt
from PyQt5 import QtCore

# Qtdesginer ile oluşturulan tasarım kodları bir sınıf(class) içinde tanımlanmıştır. 
# Bu kodlardan yararlanmak için bu sınıfı miras almalıyız. bunun içinde 
# söz konusu sınıfın adını bir değişkene alıyoruz.
MainFormEditClass = main_form_ui_edit.Main_Window_ui_Edit   # Ui_MainWindow sınıf adı. main_form_ui_edit.py dosyasından geliyor.

class VLine(QFrame):
    # a simple VLine, like the one you get from designer
    def __init__(self):
        super(VLine, self).__init__()
        self.setFrameShape(self.VLine|self.Sunken)

# yeni bir sınıf oluşturarak MainFormEditClass sınıfını miras alıyoruz.
class Main_Window_Ui(MainFormEditClass): 
    
    Cont_Char_code = ["0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","127"]
    Cont_Char_symb = ["[NULL]","[SOH]","[STX]","[ETX]","[EOT]","[ENQ]","[ACK]","[BEL]","[BS]","[HT]","[LF]","[VT]","[FF]","[CR]","[SO]","[SI]","[DLE]","[DC1]","[DC2]","[DC3]","[DC4]","[NAK]","[SYN]","[ETB]","[CAN]","[EM]","[SUB]","[ESC]","[FS]","[GS]","[RS]","[US]","[SP]","[DEL]"]
    Cont_Char_desc = ["Null Character","Start of Heading","Start of Text","End-of-text character","End-of-transmission character","Enquiry character","Acknowledge character","Bell character","Backspace","Horizontal tab","Line feed","Vertical tab","Form feed","Carriage return","Shift Out","Shift In","Data Link Escape","Device Control 1","Device Control 2","Device Control 3","Device Control 4","Negative-acknowledge character","Synchronous Idle","End of Transmission Block","Cancel character","End of Medium","Substitute character","Escape character","File Separator","Group Separator","Record Separator","Unit Separator","Space","Delete"]

    user_start_val=0
    user_end_val=0
    range=0
    
    # Sınıfın örnekleme (instantiation) fonksiyonu. 
    # Bu fonksiyon sadece sınıftan bir nesne(object) üretildiğinde çalışır.
    def __init__(self):         # __init__ initilase den gelir ve bu fonksiyonun bu şekilde adlandırılması zorunludur.
        super().__init__()      # QMainWindow sınıfı içerisinde de init fonksiyonu mevcut ve
                                # bu fonksiyonun özelliklerini koruma için super() fonksiyonunu kullanıyoruz. 
        self.code_ui()          # kendi eklemelerimiz icin kendi fonksiyonumuz olan code_ui() yi çağırıyoruz.
        
    # Kendi düzenleme fonksiyonumuz
    def code_ui(self):
        
        self.progressBar = QProgressBar()
        #self.progressBar.setGeometry(QtCore.QRect(80, 80, 171, 21))
        self.progressBar.setProperty("value", 24)
        self.progressBar.setObjectName("progressBar")
        #self.cancel_btn =QPushButton()
        #self.cancel_btn.setText("Cancel")
        #self.statusBar().showMessage("bla-bla bla")
        
        
        self.statusBar().addPermanentWidget(self.progressBar)   
        #self.statusBar().addPermanentWidget(self.cancel_btn)


        #self.cancel_btn.clicked.connect(lambda: self.statusBar().showMessage("Hello "))
        #self.cancel_btn.setVisible(0)
        self.progressBar.setVisible(0)
        
       
        
        
        self.encoding_textbox.setText("ascii")
        self.start_range_textbox.setText("0")
        self.end_range_textbox.setText("127")
        # Karakter kodlaması arama yardımcı penceresi sınıfından nesne oluşturuyoruz. (compostion)
        self.search_window = search_ui_code.Search_Window_ui()
        self.search_window.setWindowModality(Qt.ApplicationModal)
        # karakter arama butonuna basılır ise   open_seacrh_window() fonksiyonunu çağır.
        self.code_btn.clicked.connect(self.open_seacrh_window)
        # karakter arama penceresinden bir sinyal gelir ise get_codec() fonksiyonunu çağır.
        self.search_window.Signal_data.connect(self.get_codec)

        # listele butonuna basılır ise List_characters() fonksiyonunu çağır
        self.list_btn.clicked.connect(self.List_characters)
        # clear butonuna basılır ise clear_form() fonksiyonunu çağır.
        self.next_btn.clicked.connect(self.increase_range)
        self.prev_btn.clicked.connect(self.decrease_range)
        self.clr_btn.clicked.connect(self.clear_form)
        # listelerden herhangi biri aşağı/yukarı hareket ettirilir ise diğerlerininde 
        # hareket etmesi için move_scrollbar() fonksiyonunu çağırıyoruz.
        self.decimal_list.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.hex_list.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.unicode_list.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.char_list.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.binary_list.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.unicode_list_2.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        
        # listelerin herhangi birinde bir seçim yapılır ise 
        # diğer listelerinde seçili hale gelmesi için set_items() fonksiyonunu çağırıyoruz.
        self.decimal_list.itemClicked.connect(self.set_items)
        self.hex_list.itemClicked.connect(self.set_items)
        self.unicode_list.itemClicked.connect(self.set_items)
        self.unicode_list_2.itemClicked.connect(self.set_items)
        self.char_list.itemClicked.connect(self.set_items)
        self.binary_list.itemClicked.connect(self.set_items)
    
        self.clr_btn.clicked.connect(self.clear_inputs)
    
    def clear_inputs(self):
        self.start_range_textbox.setText("0")
        self.end_range_textbox.setText("127")
        self.encoding_textbox.setText("Ascii")
        self.char_list.clear()
        self.decimal_list.clear()
        self.hex_list.clear()
        self.binary_list.clear()
        self.unicode_list.clear()
        self.unicode_list_2.clear()
        self.progressBar.setVisible(0)

        pass    
        
    def increase_range(self):
        # başlangıç değerini tespit ediyoruz.
        if self.checkBox_start.isChecked() == False:
            try:
                start_val = int(self.start_range_textbox.text())
                self.start_range_textbox.setText(str(start_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.start_range_textbox.setFocus()
                return
        else:
            try:
                start_val = int(self.start_range_textbox.text(),16)
                if start_val <16:
                    self.start_range_textbox.setText(str("0x0"+"{:X}".format((start_val))))
                else:
                    self.start_range_textbox.setText(str(hex(start_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.start_range_textbox.setFocus()
                return
                  
        if start_val <0:
            self.start_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.start_range_textbox.setFocus()
            return

        # bitiş değerini tespit ediyoruz.
        if self.checkBox_end.isChecked() == False:
            try:
                end_val = int(self.end_range_textbox.text())
                self.end_range_textbox.setText(str(end_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.end_range_textbox.setFocus()
                return
        else:
            try:
                end_val = int(self.end_range_textbox.text(),16)
                if end_val <16:
                    self.end_range_textbox.setText(str("0x0"+"{:X}".format((end_val))))
                else:
                    self.end_range_textbox.setText(str(hex(end_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.end_range_textbox.setFocus()
                return
                  
        if end_val <0:
            self.end_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.end_range_textbox.setFocus()
            return
            
        if start_val > end_val:
            self.get_warn(self,"End value must be equal or greater than start value...")
            self.end_range_textbox.setFocus()
            return           
            
        if end_val-start_val >80000:
            self.get_warn(self,"Range too big.")
            self.end_range_textbox.setFocus()
            return                  
        # bitiş değerini aldık...
        self.range= end_val-start_val
        print(self.range)
        print(start_val)
        print(end_val)
        
        if self.checkBox_start.isChecked() == False:
            self.start_range_textbox.setText(str(start_val+self.range))
        else:
            self.start_range_textbox.setText(str(hex(start_val+self.range)))
        
        if self.checkBox_end.isChecked() == False:   
            self.end_range_textbox.setText(str((end_val+self.range)))
        else:
            self.end_range_textbox.setText(str((hex(end_val+self.range))))
        self.List_characters()
    
    def decrease_range(self):
        # başlangıç değerini tespit ediyoruz.
        if self.checkBox_start.isChecked() == False:
            try:
                start_val = int(self.start_range_textbox.text())
                self.start_range_textbox.setText(str(start_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.start_range_textbox.setFocus()
                return
        else:
            try:
                start_val = int(self.start_range_textbox.text(),16)
                if start_val <16:
                    self.start_range_textbox.setText(str("0x0"+"{:X}".format((start_val))))
                else:
                    self.start_range_textbox.setText(str(hex(start_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.start_range_textbox.setFocus()
                return
                  
        if start_val <0:
            self.start_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.start_range_textbox.setFocus()
            return

        # bitiş değerini tespit ediyoruz.
        if self.checkBox_end.isChecked() == False:
            try:
                end_val = int(self.end_range_textbox.text())
                self.end_range_textbox.setText(str(end_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.end_range_textbox.setFocus()
                return
        else:
            try:
                end_val = int(self.end_range_textbox.text(),16)
                if end_val <16:
                    self.end_range_textbox.setText(str("0x0"+"{:X}".format((end_val))))
                else:
                    self.end_range_textbox.setText(str(hex(end_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.end_range_textbox.setFocus()
                return
                  
        if end_val <0:
            self.end_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.end_range_textbox.setFocus()
            return
            
        if start_val > end_val:
            self.get_warn(self,"End value must be equal or greater than start value...")
            self.end_range_textbox.setFocus()
            return           
            
        if end_val-start_val >80000:
            self.get_warn(self,"Range too big.")
            self.end_range_textbox.setFocus()
            return                  
        # bitiş değerini aldık...
        
        if int(start_val) <1:
            return       
        
        self.range= end_val-start_val
        print(self.range)
        print(start_val)
        print(end_val)


        if int(start_val) <0:
            self.start_range_textbox.setText("0")
        
        if self.checkBox_start.isChecked() == False:
            self.start_range_textbox.setText(str(start_val-self.range))
        else:
            self.start_range_textbox.setText(str(hex(start_val-self.range)))
        
        if self.checkBox_end.isChecked() == False:   
            self.end_range_textbox.setText(str((end_val-self.range)))
        else:
            self.end_range_textbox.setText(str((hex(end_val-self.range))))
        self.List_characters()

    # listeleri senkronize seçili hale getiren fonksiyon.
    def set_items(self,val):
        # fonksiyona veri gönderenden (hangi listeye tıklandıysa) hangi item in seçili olduğunu alıyoruz.
        selected_item=self.sender().currentRow()        
        self.decimal_list.setCurrentRow(selected_item)  
        self.hex_list.setCurrentRow(selected_item)
        self.unicode_list.setCurrentRow(selected_item) 
        self.unicode_list_2.setCurrentRow(selected_item) 
        self.char_list.setCurrentRow(selected_item)
        self.binary_list.setCurrentRow(selected_item)        
        
    # listelerin senkronize hareketini sağlayan fonksiyon.
    def move_scrollbar(self,value):
        
        self.decimal_list.verticalScrollBar().setValue(value)
        self.hex_list.verticalScrollBar().setValue(value)
        self.unicode_list.verticalScrollBar().setValue(value)   
        self.char_list.verticalScrollBar().setValue(value)
        self.binary_list.verticalScrollBar().setValue(value) 
        self.unicode_list_2.verticalScrollBar().setValue(value)
    def List_characters(self):
        
        # herhangi bir giriş yapılmamış ise uyarı veriyoruz.
        if self.start_range_textbox.text()=="":
            self.get_warn(self, "Please input Start Value")
            self.start_range_textbox.setFocus()
            return
        
        if self.end_range_textbox.text()=="":
            self.get_warn(self, "Please input End Value")
            self.end_range_textbox.setFocus()
            return     
        
        # giriş değerleri için değişken tanımlıyoruz.
        start_val = 0
        end_val = 0
        
        # başlangıç değerini tespit ediyoruz.
        if self.checkBox_start.isChecked() == False:
            try:
                start_val = int(self.start_range_textbox.text())
                self.start_range_textbox.setText(str(start_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.start_range_textbox.setFocus()
                return
        else:
            try:
                start_val = int(self.start_range_textbox.text(),16)
                if start_val <16:
                    self.start_range_textbox.setText(str("0x0"+"{:X}".format((start_val))))
                else:
                    self.start_range_textbox.setText(str(hex(start_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.start_range_textbox.setFocus()
                return
                  
        if start_val <0:
            self.start_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.start_range_textbox.setFocus()
            return

        # bitiş değerini tespit ediyoruz.
        if self.checkBox_end.isChecked() == False:
            try:
                end_val = int(self.end_range_textbox.text())
                self.end_range_textbox.setText(str(end_val))
            except:
                self.get_warn(self, "Please input Only Number. Or Set Hex Option")
                self.end_range_textbox.setFocus()
                return
        else:
            try:
                end_val = int(self.end_range_textbox.text(),16)
                if end_val <16:
                    self.end_range_textbox.setText(str("0x0"+"{:X}".format((end_val))))
                else:
                    self.end_range_textbox.setText(str(hex(end_val)))
            except:
                self.get_warn(self, "Please input Only regular positive value")
                self.end_range_textbox.setFocus()
                return
                  
        if end_val <0:
            self.end_range_textbox.clear()
            self.get_warn(self,"Please input positive value")
            self.end_range_textbox.setFocus()
            return
            
        if start_val > end_val:
            self.get_warn(self,"End value must be equal or greater than start value...")
            self.end_range_textbox.setFocus()
            return           
            
        if end_val-start_val >80000:
            self.get_warn(self,"Range too big.")
            self.end_range_textbox.setFocus()
            return                  
        # başlama bitiş değerlerini sorunsuz aldık.
  
        # print(start_val)
        # print(end_val)
        
        # karakter kodlamasını kontrol edelim.
        if self.encoding_textbox.text()=="":
            self.get_warn(self,"Please input a character encoding...")
            self.encoding_textbox.setFocus()
            return      
        
        codec = self.encoding_textbox.text()              

        self.char_list.clear()
        self.decimal_list.clear()
        self.hex_list.clear()
        self.binary_list.clear()
        self.unicode_list.clear()
        self.unicode_list_2.clear()
        self.progressBar.setVisible(1)
        self.progressBar.setMinimum(start_val)
        self.progressBar.setMaximum(end_val)
        # istenilen aralık için bir döngü kuruyoruz.

        for k in range(start_val,end_val+1):

            self.progressBar.setValue(k)
            self.statusBar().showMessage("Looking : "+ str(k))
            
            # döngüdeki rakamı byte haline getirdik. Encoding işlemi için byte türünde değere ihtiyaç var.
            b =k.to_bytes(((k.bit_length()+7)//8),byteorder="big")           
            
            show_char =[]  # gösterim sağlanacak karakter için boş değişken tanımlıyoruz.
            show_desc =[]  # gösterim için karakter açıklması
            unic_name =[]  # gösterim için unicode adı
            unic_code=[]
            
            try: #karakter karşılığı elde edebiliyormuyuz bakalım...
                character = b.decode(codec)   
                #character= chr(97)+chr(65)
                # birden çok karakter olası ihtimaline karşı döngüye giriyoruz.
                
                for i in range (len(character)):
                
                        # karakter dizisinin n. elemanı yazdırılabilir ise listeye ekliyoruz.
                        if character[i].isprintable() == True:
                            
                            #print("Yazdırılabilir.")
                            #print(character[i])
                            show_char.append(character[i])
                            unic_code.append("U"+str(hex(ord(character[i]))).lstrip("0x").zfill(4).upper())
                            
                            unic_name.append(unicodedata.name(character[i]))
                        else:
                            
                            #print("özel Karakter")
                            cc= ord(character[i])
                            #print (cc)
                            
                            
                            for s in range(len(self.Cont_Char_code)):
                                if int(self.Cont_Char_code[s])==int(cc):
                                    #print(Cont_Char_symb[s])
                                    show_char.append(self.Cont_Char_symb[s])
                                    show_desc.append(self.Cont_Char_desc[s])
                                    unic_name.append(self.Cont_Char_desc[s])
                                    unic_code.append("U"+str(hex(ord(character[i]))).lstrip("0x").zfill(4).upper())
                                    #Cont_Char_desc
                        
                if k==0:
                    show_char.append(self.Cont_Char_symb[0])
                    unic_name.append(self.Cont_Char_desc[0])
                    unic_code.append("U0000")
                
                # Karakter bilgilerini listelere ekleyelim.
                # print ("".join(show_char))
                #─ show_desc
                # print("".join(show_char))
                self.decimal_list.addItem(str(k))
                self.hex_list.addItem("0x"+ str(hex(k)).lstrip("0x").zfill((len(hex(k))-2) if (len(hex(k))-2)%2==0 else (len(hex(k))-2)+1).upper())

                
                if k==0:
                    self.binary_list.addItem("00000000")
                else:
                    self.binary_list.addItem(" ".join(f"{(i):08b}" for i in b)) 
                   
                   
                self.unicode_list_2.addItem ("+".join(unic_name).upper())
                self.unicode_list_2.item(self.unicode_list_2.count()-1).setToolTip("+".join(unic_name).upper()) 
                
                self.unicode_list.addItem ("+".join(unic_code).upper()) 
                self.unicode_list.item(self.unicode_list.count()-1).setToolTip("+".join(unic_code).upper())
                                    
                self.char_list.addItem("".join(show_char)) 
                self.char_list.item(self.char_list.count()-1).setToolTip("".join(show_char))    
                self.char_list.item(self.char_list.count()-1).setTextAlignment(Qt.AlignCenter)
                self.char_list.item(self.char_list.count()-1).setSizeHint(QtCore.QSize(1, 17))
                
                
                # tek karakterden fazla ise komple kaldır...
                if len(character)>1 and self.checkBox_invalids_2.isChecked()==False:
                    self.decimal_list.takeItem(self.decimal_list.count()-1)
                    self.hex_list.takeItem(self.hex_list.count()-1)
                    self.binary_list.takeItem(self.binary_list.count()-1)
                    self.unicode_list.takeItem(self.unicode_list.count()-1)
                    self.unicode_list_2.takeItem(self.unicode_list_2.count()-1)
                    self.char_list.takeItem(self.char_list.count()-1)
                   
 
            except:
                if self.checkBox_invalids.isChecked()==True:
                    self.decimal_list.addItem(str(k))
                    self.hex_list.addItem("0x"+ str(hex(k)).lstrip("0x").zfill((len(hex(k))-2) if (len(hex(k))-2)%2==0 else (len(hex(k))-2)+1).upper())
                    self.binary_list.addItem(" ".join(f"{(i):08b}" for i in b))
                    self.char_list.addItem("")
                    self.unicode_list.addItem("")
                    self.unicode_list_2.addItem("")
                pass                    
          
        
        #self.get_warn(self, "Uyarı Mesajı")
        
        
    def get_warn(self, object, msg="Warning..."):   
        #print(msg)
        QMessageBox.warning(self,"Warning..!", msg)
        pass
    
    def clear_form(self):
        print("clear")
        pass

    def get_codec(self, data):
        #self.show()
        if data !="":
            self.encoding_textbox.setText(data)
        print(data)
        
    def open_seacrh_window(self):
        # arama penceresindeki arama kutusunu temizle
        self.search_window.lineEdit.clear()
        # arama penceresini aç
        self.search_window.show()
        #self.hide()
        
        

        

# dosyayı tek başına test etmek için kullanılan opsiyonel kodlamalar. 
# eğer dosya tek başına(başka bir dosyaya dahil edilmeden) çalışıyor ise;

if __name__=="__main__": 
    
    # bir uygulama oluşturmak için QApplication sınıfından (sys.argv) ile bir (pencere) uygulama nesnesi oluşturuyoruz.
    uygulama = QApplication(sys.argv)
    # artık bir uygulmamaız var.
    # yazdığımız Search_Window_ui_Edit sınıfını örnekleyerek pencere nesnemizi oluşturuyoruz.
    window = Main_Window_Ui()
    # artık birde penceremiz var.

    window.show()   # penecereyi göster.
    sys.exit(uygulama.exec_())  # pencerenin X butonuna basılır ise uygulamayı sonlandır.