# Bu dosya ana pencere için ilave görsel düzenlemeleri sağlar.
# ana pencere için kod düzenlemeri "main_form_ui_code" dosyasında yapılmalıdır. 
# main_form.ui* dosyası QtDesigner ile oluşturulmuştur.
# main_form_ui_to_py.py** dosyası ui uzantılı QtDesigner dosyasını main_form_ui.py dosyasına dönüştürür.
# main_form_ui.py*** dosyası uic kütüphanesi ile python kodlarına dönüştürülmiş QtDesigner tasarımını içerir
# *,**,*** Bu üç dosyaya müdahele edilmemelidir. 

import sys              # sys modulunu içe aktarıyoruz. Bu dosyada sadece test için gereklidir.
import main_form_ui     # QtDesigner tarafından oluşturulan tasarım kodlarını barındıran dosyayı dahil ediyoruz.

# main_form_ui.py dosyasındaki kodlar sadece tasarım içindir. Bu dosyada bir 
# pencere ve uygulama oluşturulacağı için aşağıdaki modulleri de koda dahil ediyoruz.
from PyQt5.QtWidgets import QWidget,QApplication,QMainWindow
from PyQt5.Qt import Qt
from PyQt5.QtCore import QRegExp
from PyQt5.QtGui import QRegExpValidator

# Qtdesginer ile oluşturulan tasarım kodları bir sınıf(class) içinde tanımlanmıştır. 
# Bu kodlardan yararlanmak için bu sınıfı miras almalıyız. bunun içinde 
# söz konusu sınıfın adını bir değişkene alıyoruz.
QtDesigner_Class = main_form_ui.Ui_MainWindow   # Ui_Form sınıf adı. main_form_ui.py dosyasından geliyor.

# yeni bir sınıf oluşturarak Qt nin QMainWindow sınıfını ve QtDesigner_Class sınıfını miras alıyoruz.
class Main_Window_ui_Edit(QMainWindow,QtDesigner_Class): 
    
    # Sınıfın örnekleme (instantiation) fonksiyonu. 
    # Bu fonksiyon sadece sınıftan bir nesne(object) üretildiğinde çalışır.
    def __init__(self):         # __init__ initilase den gelir ve bu fonksiyonun bu şekilde adlandırılması zorunludur.
        super().__init__()      # QMainWindow sınıfı içerisinde de init fonksiyonu mevcut ve
                                # bu fonksiyonun özelliklerini koruma için super() fonksiyonunu kullanıyoruz. 
        self.setupUi(self)      # setupUi() fonksiyonunu QtDesigner_Class sınıfından miras aldık. Çalıştırıyoruz.
                                # bu fonksiyon tasarımı barındırıyor.
        self.edit_ui()          # kendi eklemelerimiz icin kendi fonksiyonumuz olan edit_ui() yi çağırıyoruz.
        
    # Kendi düzenleme fonksiyonumuz
    def edit_ui(self):
        self.setFixedSize(785, 515)         # pencere boyutunu sabitle.
        self.setWindowTitle("Character Encoding Tool.. V.1.0")  # pencere başlığını ayarla.
        # Başlangıç ve bitiş  değeri kutusu içeriğini ortala
        self.start_range_textbox.setAlignment(Qt.AlignCenter)
        self.end_range_textbox.setAlignment(Qt.AlignCenter)
        self.encoding_textbox.setAlignment(Qt.AlignCenter)
        # Başlangıç ve bitiş değeri kutusu için  sadece [0-9,A-F,a-f] aralığındakileri kabul et.
        self.start_range_textbox.setValidator(QRegExpValidator(QRegExp("[0-9,A-F,a-f]*")))
        self.end_range_textbox.setValidator(QRegExpValidator(QRegExp("[0-9,A-F,a-f]*")))

        #self.decimal_list.setItemAlignment(Qt.AlignRight)

        # En sağdaki hariç olmak üzere listeleme kutuları için kaydırma çubuklarını iptal et.
        self.decimal_list.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.decimal_list.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.hex_list.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.hex_list.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.unicode_list.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.unicode_list.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        
        self.char_list.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.char_list.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        
        self.binary_list.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.binary_list.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        
        self.unicode_list_2.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)

# dosyayı tek başına test etmek için kullanılan opsiyonel kodlamalar. 
# eğer dosya tek başına(başka bir dosyaya dahil edilmeden) çalışıyor ise;

if __name__=="__main__": 
    
    # bir uygulama oluşturmak için QApplication sınıfından (sys.argv) ile bir (pencere) uygulama nesnesi oluşturuyoruz.
    uygulama = QApplication(sys.argv)
    # artık bir uygulmamaız var.
    # yazdığımız Search_Window_ui_Edit sınıfını örnekleyerek pencere nesnemizi oluşturuyoruz.
    window = Main_Window_ui_Edit()
    # artık birde penceremiz var.

    window.show()   # penecereyi göster.
    sys.exit(uygulama.exec_())  # pencerenin X butonuna basılır ise uygulamayı sonlandır.