# Bu dosya search penceresi için kodlamaları barındırır..
# search penceresi için kod görsel düzenlemeler "search_ui_edit" dosyasında yapılmalıdır. 
# search.ui* dosyası QtDesigner ile oluşturulmuştur.
# search_ui_to_py.py** dosyası ui uzantılı QtDesigner dosyasını search_ui.py dosyasına dönüştürür.
# search_ui.py*** dosyası uic kütüphanesi ile python kodlarına dönüştürülmiş QtDesigner tasarımını içerir
# *,**,*** Bu üç dosyaya müdahele edilmemelidir. 

import sys              # sys modulunu içe aktarıyoruz. Bu dosyada sadece test için gereklidir.
import search_ui_edit   # Kod ekleyeceğimiz görsel düzenleme barındıran dosyayı koda dahil ediyoruz.

# pencere ve uygulama oluşturulacağı için aşağıdaki modulleri de koda dahil ediyoruz.
from PyQt5.QtWidgets import QApplication #,QWidget
# from PyQt5.QtCore import QEvent
from PyQt5.Qt import Qt

# ana pencereye veri göndermek için sinyal modulunu ekliyoruz.
from PyQt5.QtCore import pyqtSignal

# Görsel düzenleme içeren tasarım kodları bir sınıf(class) içinde tanımlanmıştır. 
# Bu kodlardan yararlanmak için bu sınıfı miras almalıyız. bunun içinde 
# söz konusu sınıfın adını bir değişkene alıyoruz.

SearchFormEditClass = search_ui_edit.Search_Window_ui_Edit # Search_Window_ui_Edit sınıf adı. search_ui_edit.py dosyasından geliyor.

# yeni bir sınıf oluşturarak  Search_Window_ui_Edit sınıfını miras alıyoruz.
class Search_Window_ui(SearchFormEditClass): 
    
    # Karakter kodlamalarını (codecs), takma isimleri(aliases), hangi dillerde (languages) kullanıldıklarını 
    # birer dizi şeklinde sınıfımıza nitelik olarak ekliyoruz. burada dikkat edilmesi gereken husus dizilerin
    # eleman sayıları eşit olmalıdır ve dizilerin n. elemanları bir biri ile ilişkilidir. 
    codecs    = (["ascii"],          ["big5"],["big5hkscs"],["cp037"],["cp273"],["cp424"],["cp437"],["cp500"],["cp720"],["cp737"],["cp775"],["cp850"],["cp852"],["cp855"],["cp856"],["cp857"],["cp858"],["cp860"],["cp861"],["cp862"],["cp863"],["cp864"],["cp865"],["cp866"],["cp869"],["cp874"],["cp875"],["cp932"],["cp949"],["cp950"],["cp1006"],["cp1026"],["cp1125"],["cp1140"],["cp1250"],["cp1251"],["cp1252"],["cp1253"],["cp1254"],["cp1255"],["cp1256"],["cp1257"],["cp1258"],["euc_jp"],["euc_jis_2004"],["euc_jisx0213"],["euc_kr"],["gb2312"],["gbk"],["gb18030"],["hz"],["iso2022_jp"],["iso2022_jp_1"],["iso2022_jp_2"],["iso2022_jp_2004"],["iso2022_jp_3"],["iso2022_jp_ext"],["iso2022_kr"],["latin_1"],["iso8859_2"],["iso8859_3"],["iso8859_4"],["iso8859_5"],["iso8859_6"],["iso8859_7"],["iso8859_8"],["iso8859_9"],["iso8859_10"],["iso8859_11"],["iso8859_13"],["iso8859_14"],["iso8859_15"],["iso8859_16"],["johab"],["koi8_r"],["koi8_t"],["koi8_u"],["kz1048"],["mac_cyrillic"],["mac_greek"],["mac_iceland"],["mac_latin2"],["mac_roman"],["mac_turkish"],["ptcp154"],["shift_jis"],["shift_jis_2004"],["shift_jisx0213"],["utf_32"],["utf_32_be"],["utf_32_le"],["utf_16"],["utf_16_be"],["utf_16_le"],["utf_7"],["utf_8"],["utf_8_sig"])
    aliases   = (["646, us-ascii"],  ["big5-tw, csbig5"],["big5-hkscs, hkscs"],["IBM037, IBM039"],["273, IBM273, csIBM273"],["EBCDIC-CP-HE, IBM424"],["437, IBM437"],["EBCDIC-CP-BE, EBCDIC-CP-CH, IBM500"],[""],[""],["IBM775"],["850, IBM850"],["852, IBM852"],["855, IBM855"],[""],["857, IBM857"],["858, IBM858"],["860, IBM860"],["861, CP-IS, IBM861"],["862, IBM862"],["863, IBM863"],["IBM864"],["865, IBM865"],["866, IBM866"],["869, CP-GR, IBM869"],[""],[""],["932, ms932, mskanji, ms-kanji"],["949, ms949, uhc"],["950, ms950"],[""],["ibm1026"],["1125, ibm1125, cp866u, ruscii"],["ibm1140"],["windows-1250"],["windows-1251"],["windows-1252"],["windows-1253"],["windows-1254"],["windows-1255"],["windows-1256"],["windows-1257"],["windows-1258"],["eucjp, ujis, u-jis"],["jisx0213, eucjis2004"],["eucjisx0213"],["euckr, korean, ksc5601, ks_c-5601, ks_c-5601-1987, ksx1001, ks_x-1001"],["chinese, csiso58gb231280, euc-cn, euccn, eucgb2312-cn, gb2312-1980, gb2312-80, iso-ir-58"],["936, cp936, ms936"],["gb18030-2000"],["hzgb, hz-gb, hz-gb-2312"],["csiso2022jp, iso2022jp, iso-2022-jp"],["iso2022jp-1, iso-2022-jp-1"],["iso2022jp-2, iso-2022-jp-2"],["iso2022jp-2004, iso-2022-jp-2004"],["iso2022jp-3, iso-2022-jp-3"],["iso2022jp-ext, iso-2022-jp-ext"],["csiso2022kr, iso2022kr, iso-2022-kr"],["iso-8859-1, iso8859-1, 8859, cp819, latin, latin1, L1"],["iso-8859-2, latin2, L2"],["iso-8859-3, latin3, L3"],["iso-8859-4, latin4, L4"],["iso-8859-5, cyrillic"],["iso-8859-6, arabic"],["iso-8859-7, greek, greek8"],["iso-8859-8, hebrew"],["iso-8859-9, latin5, L5"],["iso-8859-10, latin6, L6"],["iso-8859-11, thai"],["iso-8859-13, latin7, L7"],["iso-8859-14, latin8, L8"],["iso-8859-15, latin9, L9"],["iso-8859-16, latin10, L10"],["cp1361, ms1361"],[""],[""],[""],["kz_1048, strk1048_2002, rk1048"],["maccyrillic"],["macgreek"],["maciceland"],["maclatin2, maccentraleurope, mac_centeuro"],["macroman, macintosh"],["macturkish"],["csptcp154, pt154, cp154, cyrillic-asian"],["csshiftjis, shiftjis, sjis, s_jis"],["shiftjis2004, sjis_2004, sjis2004"],["shiftjisx0213, sjisx0213, s_jisx0213"],["U32, utf32"],["UTF-32BE"],["UTF-32LE"],["U16, utf16"],["UTF-16BE"],["UTF-16LE"],["U7, unicode-1-1-utf-7"],["U8, UTF, utf8, cp65001"],[""])
    languages = (["English"],        ["Traditional Chinese"],["Traditional Chinese"],["English"],["German New in version 3.4."],["Hebrew"],["English"],["Western Europe"],["Arabic"],["Greek"],["Baltic languages"],["Western Europe"],["Central and Eastern Europe"],["Bulgarian, Byelorussian, Macedonian, Russian, Serbian"],["Hebrew"],["Turkish"],["Western Europe"],["Portuguese"],["Icelandic"],["Hebrew"],["Canadian"],["Arabic"],["Danish, Norwegian"],["Russian"],["Greek"],["Thai"],["Greek"],["Japanese"],["Korean"],["Traditional Chinese"],["Urdu"],["Turkish"],["Ukrainian New in version 3.4."],["Western Europe"],["Central and Eastern Europe"],["Bulgarian, Byelorussian, Macedonian, Russian, Serbian"],["Western Europe"],["Greek"],["Turkish"],["Hebrew"],["Arabic"],["Baltic languages"],["Vietnamese"],["Japanese"],["Japanese"],["Japanese"],["Korean"],["Simplified Chinese"],["Unified Chinese"],["Unified Chinese"],["Simplified Chinese"],["Japanese"],["Japanese"],["Japanese, Korean, Simplified Chinese, Western Europe, Greek"],["Japanese"],["Japanese"],["Japanese"],["Korean"],["Western Europe"],["Central and Eastern Europe"],["Esperanto, Maltese"],["Baltic languages"],["Bulgarian, Byelorussian, Macedonian, Russian, Serbian"],["Arabic"],["Greek"],["Hebrew"],["Turkish"],["Nordic languages"],["Thai languages"],["Baltic languages"],["Celtic languages"],["Western Europe"],["South-Eastern Europe"],["Korean"],["Russian"],["Tajik New in version 3.5."],["Ukrainian"],["Kazakh New in version 3.5."],["Bulgarian, Byelorussian, Macedonian, Russian, Serbian"],["Greek"],["Icelandic"],["Central and Eastern Europe"],["Western Europe"],["Turkish"],["Kazakh"],["Japanese"],["Japanese"],["Japanese"],["all languages"],["all languages"],["all languages"],["all languages"],["all languages"],["all languages"],["all languages"],["all languages"],["all languages"])
    
    # pyqtSignal sınıfını örnekleyerek bir sinyal nesnesi oluşturuyoruz. 
    Signal_data = pyqtSignal(str)
    
    # Sınıfın örnekleme (instantiation) fonksiyonu. 
    # Bu fonksiyon sadece sınıftan bir nesne(object) üretildiğinde çalışır.
    def __init__(self):         # __init__ initilase den gelir ve bu fonksiyonun bu şekilde adlandırılması zorunludur.
        super().__init__()      # Search_Window_ui_Edit sınıfı içerisinde de init fonksiyonu mevcut ve
                                # bu fonksiyonun özelliklerini korumak için super() fonksiyonunu kullanıyoruz. 
        self.code_ui()          # kendi kodlamalarımız icin kendi fonksiyonumuz olan code_ui() yi çağırıyoruz.
        
        
    # kodlamalarımızı içeren temel fonksiyon
    def code_ui(self):
        
        # iptal butonuna basılır ise cancel_func() fonksiyonunu çağırıyoruz.
        self.btn_cancel.pressed.connect(self.cancel_func)
        
        # ok butonuna basılır ise btn_ok_press() fonksiyonunu çağırıyoruz.
        self.btn_ok.pressed.connect(self.check_selection)
        
        self.check_arrays() # codec dizilerini kontrol ediyoruz.
        self.fill_lists()  # listeleme kutularını codec dizileri ile doluran fonksiyonu çağırıyoruz.
        
        # arama kutusunu giriş yapılır ise listeleri tekrar güncelliyoruz.
        self.lineEdit.textChanged.connect(self.fill_lists)
        
        # listelerden herhangi biri aşağı/yukarı hareket ettirilir ise diğerlerininde 
        # hareket etmesi için move_scrollbar() fonksiyonunu çağırıyoruz.
        self.listWidget_1.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.listWidget_2.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        self.listWidget_3.verticalScrollBar().valueChanged.connect(self.move_scrollbar)
        
        # listelerin herhangi birinde bir seçim yapılır ise 
        # diğer listelerinde seçili hale gelmesi için set_items() fonksiyonunu çağırıyoruz.
        self.listWidget_1.itemClicked.connect(self.set_items)
        self.listWidget_2.itemClicked.connect(self.set_items)
        self.listWidget_3.itemClicked.connect(self.set_items)
        
        # listelerden birine çift tıklama yapılır ise
        self.listWidget_1.doubleClicked.connect(self.check_selection)
        self.listWidget_2.doubleClicked.connect(self.check_selection)
        self.listWidget_3.doubleClicked.connect(self.check_selection)
    
    # seçim kontrolü yapan fonksiyon
    def check_selection(self):
        
        # birinci listede herhangi bir eleman seçili ise
        if self.listWidget_1.currentRow() > -1:
            # print(self.listWidget_1.currentItem().text())
            # print(self.listWidget_1.item(self.listWidget_1.currentRow()).text())
            # seçimi sinyal olarak gönder.
            self.Signal_data.emit(self.listWidget_1.currentItem().text())
            self.hide()
            
         

    # iptal butonuna basıldı
    def cancel_func(self):
        self.Signal_data.emit("")
        self.hide()


    # listeleme kutularını dolduran fonksiyon    
    def fill_lists(self):
        # öncelikle listeri temizliyoruz/temiz(boş) olduklarından emin oluyoruz.
        self.listWidget_1.clear()
        self.listWidget_2.clear()
        self.listWidget_3.clear()

        # print("ok")
        #a= self.listWidget_1.count()
        
        # arama kutusuna girilen harfler veya kelimeyi alıyoruz.
        # henüz bir giriş yapılmamış ise hiçbir harf/kelime yoktur...
        search=self.lineEdit.text().lower()     # ayrıca lower() ile giriş yapılan içeriği küçük harfe dönüştürüyoruz.
        
        # kodlama dizisindeki eleman sayısı kadar bir döngü oluşturuyoruz.
        for z in range(len(self.codecs)):
            #print(x)
            #print(codecs[z])
            
            # eğer arama kelimesi codecs dizinin n. elemanında var ise 
            if search in str(self.codecs[z]).lower():
                # print(str(self.codecs[z]).upper()[2:-2])
                # eşleşme var ise tüm dizilerden ilgili elemanları listelere ekliyoruz.
                # 1. listeye codec dizisinin n. elemanını ekle
                self.listWidget_1.addItem(str(self.codecs[z]).upper()[2:-2])
                # 2. listeye aliases dizisinin n. elemanını ekle
                self.listWidget_2.addItem(str(self.aliases[z]).upper()[2:-2])
                # 3. listeye languages dizisinin n. elemanını ekle
                self.listWidget_3.addItem(str(self.languages[z]).upper()[2:-2])
                # listeleme kutusuna eklenen içeriğin kutuya sığmama ihtimaline karşı 
                # balon ipucu(tooltip) ile içeriğin tamamının görüntülenmesini sağlıyoruz. 
                self.listWidget_1.item(self.listWidget_1.count()-1).setToolTip(str(self.codecs[z]).upper()[2:-2])
                self.listWidget_2.item(self.listWidget_2.count()-1).setToolTip(str(self.aliases[z]).upper()[2:-2])
                self.listWidget_3.item(self.listWidget_3.count()-1).setToolTip(str(self.languages[z]).upper()[2:-2])
            
            # eğer arama kelimesi codecs dizisinde yok ama aliases dizisinde var ise.
            elif search in str(self.aliases[z]).lower():
                # eşleşme var ise tüm dizilerden ilgili elemanları listelere ekliyoruz.
                # 1. listeye codec dizisinin n. elemanını ekle
                self.listWidget_1.addItem(str(self.codecs[z]).upper()[2:-2])
                # 2. listeye aliases dizisinin n. elemanını ekle
                self.listWidget_2.addItem(str(self.aliases[z]).upper()[2:-2])
                # 3. listeye languages dizisinin n. elemanını ekle
                self.listWidget_3.addItem(str(self.languages[z]).upper()[2:-2])
                # listeleme kutusuna eklenen içeriğin kutuya sığmama ihtimaline karşı 
                # balon ipucu(tooltip) ile içeriğin tamamının görüntülenmesini sağlıyoruz. 
                self.listWidget_1.item(self.listWidget_1.count()-1).setToolTip(str(self.codecs[z]).upper()[2:-2])
                self.listWidget_2.item(self.listWidget_2.count()-1).setToolTip(str(self.aliases[z]).upper()[2:-2])
                self.listWidget_3.item(self.listWidget_3.count()-1).setToolTip(str(self.languages[z]).upper()[2:-2])
            
            # eğer arama kelimesi codecs dizisinde yok ama aliases dizisinde var ise.
            elif search in str(self.languages[z]).lower():
                # eşleşme var ise tüm dizilerden ilgili elemanları listelere ekliyoruz.
                # 1. listeye codec dizisinin n. elemanını ekle
                self.listWidget_1.addItem(str(self.codecs[z]).upper()[2:-2])
                # 2. listeye aliases dizisinin n. elemanını ekle
                self.listWidget_2.addItem(str(self.aliases[z]).upper()[2:-2])
                # 3. listeye languages dizisinin n. elemanını ekle
                self.listWidget_3.addItem(str(self.languages[z]).upper()[2:-2])
                # listeleme kutusuna eklenen içeriğin kutuya sığmama ihtimaline karşı 
                # balon ipucu(tooltip) ile içeriğin tamamının görüntülenmesini sağlıyoruz. 
                self.listWidget_1.item(self.listWidget_1.count()-1).setToolTip(str(self.codecs[z]).upper()[2:-2])
                self.listWidget_2.item(self.listWidget_2.count()-1).setToolTip(str(self.aliases[z]).upper()[2:-2])
                self.listWidget_3.item(self.listWidget_3.count()-1).setToolTip(str(self.languages[z]).upper()[2:-2])

    # listeleri senkronize seçili hale getiren fonksiyon.
    def set_items(self,val):
        # fonksiyona veri gönderenden (hangi listeye tıklandıysa) hangi item in seçili olduğunu alıyoruz.
        selected_item=self.sender().currentRow()        
        self.listWidget_1.setCurrentRow(selected_item)  
        self.listWidget_2.setCurrentRow(selected_item)
        self.listWidget_3.setCurrentRow(selected_item)    
    
    # listelerin senkronize hareketini sağlayan fonksiyon.
    def move_scrollbar(self,value):
        
        self.listWidget_1.verticalScrollBar().setValue(value)
        self.listWidget_2.verticalScrollBar().setValue(value)
        self.listWidget_3.verticalScrollBar().setValue(value)
        #self.vs.blockSignals(True)
        #self.vs.setValue(value)
        #self.vs.blockSignals(False)    
    
    # Karaktek dizilerinin eşit olduğundan emin oluyoruz.     
    def check_arrays(self):
        # dizilerin eleman sayısı bir birine eşit mi?
        if (len(self.codecs)==len(self.aliases)) and (len(self.codecs)==len(self.languages)) and (len(self.aliases)==len(self.languages)):
            # print("ok")
            return
        else:
            # Programcı için Dahili uyarı
            print("Please check character coding Arrays. item count are not equal!")
            quit()
            













# dosyayı tek başına test etmek için kullanılan opsiyonel kodlamalar. 
# eğer dosya tek başına(başka bir dosyaya dahil edilmeden) çalışıyor ise;

if __name__=="__main__": 
    
    # bir uygulama oluşturmak için QApplication sınıfından (sys.argv) ile bir (pencere) uygulama nesnesi oluşturuyoruz.
    uygulama = QApplication(sys.argv)
    # artık bir uygulmamaız var.
    # yazdığımız Search_Window_ui_Edit sınıfını örnekleyerek pencere nesnemizi oluşturuyoruz.
    window = Search_Window_ui()
    # artık birde penceremiz var.

    window.show()   # penecereyi göster.
    sys.exit(uygulama.exec_())  # pencerenin X butonuna basılır ise uygulamayı sonlandır.    
        
