# Bu dosya search penceresi için ilave görsel düzenlemeleri sağlar.
# search penceresi için kod düzenlemeri "search_ui_code" dosyasında yapılmalıdır. 
# search.ui* dosyası QtDesigner ile oluşturulmuştur.
# search_ui_to_py.py** dosyası ui uzantılı QtDesigner dosyasını search_ui.py dosyasına dönüştürür.
# search_ui.py*** dosyası uic kütüphanesi ile python kodlarına dönüştürülmiş QtDesigner tasarımını içerir
# *,**,*** Bu üç dosyaya müdahele edilmemelidir. 

import sys              # sys modulunu içe aktarıyoruz. Bu dosyada sadece test için gereklidir.
import search_ui        # QtDesigner tarafından oluşturulan tasarım kodlarını barındıran dosyayı dahil ediyoruz.

# search_ui.py dosyasındaki kodlar sadece tasarım içindir. Bu dosyada bir 
# pencere ve uygulama oluşturulacağı için aşağıdaki modulleri de koda dahil ediyoruz.
from PyQt5.QtWidgets import QWidget,QApplication 
from PyQt5.Qt import Qt

# Qtdesginer ile oluşturulan tasarım kodları bir sınıf(class) içinde tanımlanmıştır. 
# Bu kodlardan yararlanmak için bu sınıfı miras almalıyız. bunun içinde 
# söz konusu sınıfın adını bir değişkene alıyoruz.
QtDesigner_Class = search_ui.Ui_Form   # Ui_Form sınıf adı. search_ui.py dosyasından geliyor.

# yeni bir sınıf oluşturarak Qt nin QWidget sınıfını ve QtDesigner_Class sınıfını miras alıyoruz.
class Search_Window_ui_Edit(QWidget,QtDesigner_Class): 
    
    # Sınıfın örnekleme (instantiation) fonksiyonu. 
    # Bu fonksiyon sadece sınıftan bir nesne(object) üretildiğinde çalışır.
    def __init__(self):         # __init__ initilase den gelir ve bu fonksiyonun bu şekilde adlandırılması zorunludur.
        super().__init__()      # QWidget sınıfı içerisinde de init fonksiyonu mevcut ve
                                # bu fonksiyonun özelliklerini koruma için super() fonksiyonunu kullanıyoruz. 
        self.setupUi(self)      # setupUi() fonksiyonunu QtDesigner_Class sınıfından miras aldık. Çalıştırıyoruz.
                                # bu fonksiyon tasarımı barındırıyor.
        self.edit_ui()          # kendi eklemelerimiz icin kendi fonksiyonumuz olan edit_ui() yi çağırıyoruz.
        
    # Kendi düzenleme fonksiyonumuz
    def edit_ui(self):
        self.setFixedSize(443, 342)         # pencere boyutunu sabitle.
        self.setWindowTitle("Pick a Type")  # pencere başlığını ayarla.

        # En sağdaki hariç olmak üzere listeleme kutuları için kaydırma çubuklarını iptal et.
        self.listWidget_1.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.listWidget_1.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.listWidget_2.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.listWidget_2.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.listWidget_3.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        

# dosyayı tek başına test etmek için kullanılan opsiyonel kodlamalar. 
# eğer dosya tek başına(başka bir dosyaya dahil edilmeden) çalışıyor ise;

if __name__=="__main__": 
    
    # bir uygulama oluşturmak için QApplication sınıfından (sys.argv) ile bir (pencere) uygulama nesnesi oluşturuyoruz.
    uygulama = QApplication(sys.argv)
    # artık bir uygulmamaız var.
    # yazdığımız Search_Window_ui_Edit sınıfını örnekleyerek pencere nesnemizi oluşturuyoruz.
    window = Search_Window_ui_Edit()
    # artık birde penceremiz var.

    window.show()   # penecereyi göster.
    sys.exit(uygulama.exec_())  # pencerenin X butonuna basılır ise uygulamayı sonlandır.